//
//  MTLSPreferencesTabViewController.m
//  TabViewAndAutoLayout
//
//  Created by narita on 2015/02/11.
//  Copyright (c) 2015年 narita. All rights reserved.
//

#import "MTLSPreferencesTabViewController.h"

@interface MTLSPreferencesTabViewController ()
// 制約の保存用の
@property (copy) NSArray* tabVewConstraints;
@end

@implementation MTLSPreferencesTabViewController

#pragma mark -
#pragma mark class methods

// NSTabViewのdelegateをPWTabViewControllerに指定しなければならない
+ (NSArray *)restorableStateKeyPaths
{
    return @[ @"selectedTabViewItemIndex"];
}

#pragma mark -
#pragma mark init methods

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // あらかじめTabViewに関する"制約"を保存しておく。
    // 保存しておかないと、後で制約をディアクティブにすると取れなくなってしまう。
    self.tabVewConstraints = self.view.constraints;
}

#pragma mark -
#pragma mark action methods

#pragma mark -
#pragma mark delegate/datasource methods

- (void)tabView:(NSTabView *)tabView willSelectTabViewItem:(NSTabViewItem *)tabViewItem
{
    // 保存していた制約を全部OFF
    [self.tabVewConstraints setValue:@NO forKey:@"active"];
    
    [super tabView:tabView willSelectTabViewItem:tabViewItem];
    
    
}

- (void)tabView:(NSTabView *)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem
{
    // Tabの切り替えが終わったら、保存していた制約を全部ONにしてアニメーションさせる。
    [super tabView:tabView didSelectTabViewItem:tabViewItem];

    [tabView.window layoutIfNeeded];
    
    [NSAnimationContext runAnimationGroup:^(NSAnimationContext* context)
                                         {
                                             [context setAllowsImplicitAnimation:YES];
                                             [self.tabVewConstraints setValue:@YES forKey:@"active"];
                                             [tabView.window layoutIfNeeded];
                                         }
                        completionHandler:nil];
}

#pragma mark -
#pragma mark accessor methods (in pairs)

#pragma mark -
#pragma mark Utility methods


@end
